//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "UDemo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MemPort"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------
char __fastcall GetChar(char Value)
{
  return (Value < ' ') ? '.' : Value;
}

void __fastcall TForm1::SpeedButtonShowPhysicalMemoryClick(TObject *Sender)
{
  int Line, Row, LineCount;
  String LineStr;

  try
  {
    Screen->Cursor = crHourGlass;

    Memo1->Clear();
    Memo1->Lines->BeginUpdate();

    MemPort1->Close();
    MemPort1->Address = StrToInt(EditAddress->Text);
    MemPort1->Length = StrToInt(EditLength->Text);
    MemPort1->Open();

    LineCount = MemPort1->Length / 16;
    if ((MemPort1->Length % 16) > 0)
      ++LineCount;

    for (Line = 0; Line < LineCount; ++Line)
    {
      LineStr = IntToHex(int(MemPort1->Address + Line * 16), 8) + ' ';
      for (Row = 0; Row < 16; ++Row)
        LineStr = LineStr + IntToHex(Byte(MemPort1->Memory[Line * 16 + Row]), 2) + ' ';
      for (Row = 0; Row < 16; ++Row)
        LineStr = LineStr + GetChar(MemPort1->Memory[Line * 16 + Row]);
      Memo1->Lines->Add(LineStr);
    }
  }
  __finally
  {
    Memo1->Lines->EndUpdate();
    Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
